""" The pdelab specific parts of the code generation process """

from dune.perftool.generation import (preamble,
                                      symbol,
                                      )


# Now define some commonly used generators that do not fall into a specific category
@symbol
def name_index(index):
    from ufl.classes import MultiIndex, Index
    if isinstance(index, Index):
        # This failed for index > 9 because ufl placed curly brackets around
        # return str(index)
        return "i_{}".format(index.count())
    if isinstance(index, MultiIndex):
        assert len(index) == 1
        # return str(index._indices[0])
        return "i_{}".format(index._indices[0].count())


def restricted_name(name, restriction):
    from dune.perftool import Restriction
    if restriction == Restriction.NONE:
        return name
    if restriction == Restriction.POSITIVE:
        return name + '_n'
    if restriction == Restriction.NEGATIVE:
        return name + '_s'
